(function (console) { "use strict";
var HxOverrides = function() { };
HxOverrides.cca = function(s,index) {
	var x = s.charCodeAt(index);
	if(x != x) return undefined;
	return x;
};
HxOverrides.substr = function(s,pos,len) {
	if(pos != null && pos != 0 && len != null && len < 0) return "";
	if(len == null) len = s.length;
	if(pos < 0) {
		pos = s.length + pos;
		if(pos < 0) pos = 0;
	} else if(len < 0) len = s.length + len - pos;
	return s.substr(pos,len);
};
HxOverrides.iter = function(a) {
	return { cur : 0, arr : a, hasNext : function() {
		return this.cur < this.arr.length;
	}, next : function() {
		return this.arr[this.cur++];
	}};
};
var StringBuf = function() {
	this.b = "";
};
StringBuf.prototype = {
	addSub: function(s,pos,len) {
		if(len == null) this.b += HxOverrides.substr(s,pos,null); else this.b += HxOverrides.substr(s,pos,len);
	}
};
var autoParser_AutoFormatter = function() { };
autoParser_AutoFormatter.generatedMethodName = function(pack,name) {
	var sb = new StringBuf();
	sb.b += "format_";
	var _g = 0;
	while(_g < pack.length) {
		var p = pack[_g];
		++_g;
		hamu_Naming.processName(sb,p);
		sb.b += "_";
	}
	hamu_Naming.processName(sb,name);
	return sb.b;
};
var autoParser_AutoParser = function() { };
autoParser_AutoParser.generatedMethodName = function(pack,name) {
	var sb = new StringBuf();
	sb.b += "parse_";
	var _g = 0;
	while(_g < pack.length) {
		var p = pack[_g];
		++_g;
		hamu_Naming.processName(sb,p);
		sb.b += "_";
	}
	hamu_Naming.processName(sb,name);
	return sb.b;
};
var autoParser_IBuffer = function() { };
var autoParser_ISource = function() { };
var autoParser_StringBuffer = function() {
	this.underlying = new StringBuf();
};
autoParser_StringBuffer.__interfaces__ = [autoParser_IBuffer];
autoParser_StringBuffer.prototype = {
	toString: function() {
		return this.underlying.b;
	}
	,append: function(value) {
		this.underlying.b += String.fromCharCode(value);
	}
};
var autoParser_StringSource = function(s) {
	this.data = s;
	this.index = 0;
};
autoParser_StringSource.__interfaces__ = [autoParser_ISource];
autoParser_StringSource.prototype = {
	next: function() {
		this.index += 1;
	}
	,get_current: function() {
		if(this.index < this.data.length) return HxOverrides.cca(this.data,this.index); else return null;
	}
	,get_position: function() {
		return this.index;
	}
	,set_position: function(value) {
		return this.index = value;
	}
};
var autoParser_util_StringIterator = function(s) {
	this.i = 0;
	this.s = s;
};
autoParser_util_StringIterator.iterator = function(self) {
	return new autoParser_util_StringIterator(self);
};
autoParser_util_StringIterator.prototype = {
	hasNext: function() {
		return this.i < this.s.length;
	}
	,next: function() {
		var index = this.i++;
		return HxOverrides.cca(this.s,index);
	}
};
var hamu_Builder = function(fieldsGenerator) {
	this.fieldsGenerator = fieldsGenerator;
};
var hamu_Naming = function() { };
hamu_Naming.processName = function(sb,s) {
	var i = 0;
	while(true) {
		var prev = i;
		var found = s.indexOf("_",prev);
		if(found != -1) {
			sb.addSub(s,prev,found - prev);
			sb.b += "__";
			i = found + 1;
		} else {
			sb.b += HxOverrides.substr(s,prev,null);
			break;
		}
	}
};
})(typeof console != "undefined" ? console : {log:function(){}});
